import { Request, Response, NextFunction } from "express";
import { findPisByOrigDest, findPisByCode } from "../services/pis.services";
import { setCache } from "../utils/cacheHeader.utils";

async function byStartEndCRS(req: Request, res: Response, next: NextFunction) {
//  if (!req.isAuthed) {
//    const err = new Error("Unauthorized");
//    err.status = 401;
//    return next(err);
//  }
  try {
    let startCrs = req.params.startCrs;
    let endCrs = req.params.endCrs;
    setCache(res, "public", 600)
    res.json(await findPisByOrigDest(startCrs, endCrs));
  } catch (err: any) {
    console.error("Unknown Error", err.message);
    return next(err);
  }
}

async function byCode(req: Request, res: Response, next: NextFunction) {
//  if (!req.isAuthed) {
//    const err = new Error("Unauthorized");
//    err.status = 401;
//    return next(err);
//  }
  try {
    let code = req.params.code;
    res.json(await findPisByCode(code));
  } catch (err: any) {
    console.error("Unknown Error", err.message);
    return next(err);
  }
}

module.exports = {
  byStartEndCRS,
  byCode,
};
